using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Copy.Distinct.Models;

public class AppSettings
{

    public string Company { init; get; }
    public string CopyTo { init; get; }
    public int MaxDegreeOfParallelism { init; get; }
    public int MaxValue { init; get; }
    public string WorkingDirectoryName { init; get; }

    [JsonConstructor]
    public AppSettings(string company,
                       string copyTo,
                       int maxDegreeOfParallelism,
                       int maxValue,
                       string workingDirectoryName)
    {
        Company = company;
        CopyTo = copyTo;
        MaxDegreeOfParallelism = maxDegreeOfParallelism;
        MaxValue = maxValue;
        WorkingDirectoryName = workingDirectoryName;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}