using Microsoft.Extensions.Configuration;
using System.Text.Json;

namespace View_by_Distance.Copy.Distinct.Models.Binder;

public class AppSettings
{

#nullable disable

    public string Company { get; set; }
    public int? MaxDegreeOfParallelism { get; set; }
    public int? MaxValue { get; set; }
    public string CopyTo { get; set; }
    public string WorkingDirectoryName { get; set; }

#nullable restore

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

    private static Models.AppSettings Get(AppSettings? appSettings)
    {
        Models.AppSettings result;
        if (appSettings?.MaxDegreeOfParallelism is null)
            throw new NullReferenceException(nameof(appSettings.MaxDegreeOfParallelism));
        if (appSettings?.MaxValue is null)
            throw new NullReferenceException(nameof(appSettings.MaxValue));
        result = new(
            appSettings.Company,
            appSettings.CopyTo,
            appSettings.MaxDegreeOfParallelism.Value,
            appSettings.MaxValue.Value,
            appSettings.WorkingDirectoryName
        );
        return result;
    }

    public static Models.AppSettings Get(IConfigurationRoot configurationRoot)
    {
        Models.AppSettings result;
        AppSettings? appSettings = configurationRoot.Get<AppSettings>();
        result = Get(appSettings);
        return result;
    }

}