using Microsoft.Extensions.Configuration;
using Phares.Shared;
using System.ComponentModel.DataAnnotations;
using System.Text.Json;

namespace View_by_Distance.Instance.Models.Binder;

public class Configuration
{

#nullable disable

    [Display(Name = "Check D Face and Up Dates"), Required] public bool? CheckDFaceAndUpWriteDates { get; set; }
    [Display(Name = "Check Json For Distance Results"), Required] public bool? CheckJsonForDistanceResults { get; set; }
    [Display(Name = "Copy Faces and Face Landmark for Output Resolutions"), Required] public string[] CopyFacesAndSaveFaceLandmarkForOutputResolutions { get; set; }
    [Display(Name = "CrossDirectory Max Items In Distance Collection"), Required] public int? CrossDirectoryMaxItemsInDistanceCollection { get; set; }
    [Display(Name = "Delete Possible Duplicates"), Required] public bool? DeletePossibleDuplicates { get; set; }
    [Display(Name = "Distance Factor"), Required] public int? DistanceFactor { get; set; }
    [Display(Name = "Distance Move Unable to Match by 1 Tick"), Required] public bool? DistanceMoveUnableToMatch { get; set; }
    [Display(Name = "Distance Pixel Distance Tolerance"), Required] public int? DistancePixelDistanceTolerance { get; set; }
    [Display(Name = "Distance Rename to Match"), Required] public bool? DistanceRenameToMatch { get; set; }
    [Display(Name = "Face Area Permille"), Required] public int? FaceAreaPermyriad { get; set; }
    [Display(Name = "Face Distance Hidden Image Factor"), Required] public int? FaceDistanceHiddenImageFactor { get; set; }
    [Display(Name = "Face Confidence Percent"), Required] public int? FaceConfidencePercent { get; set; }
    [Display(Name = "Face Distance Permyriad"), Required] public int? FaceDistancePermyriad { get; set; }
    [Display(Name = "Focus Directory"), Required] public string FocusDirectory { get; set; }
    [Display(Name = "Focus Model"), Required] public string FocusModel { get; set; }
    [Display(Name = "Force Face Last Write Time to Creation Time"), Required] public bool? ForceFaceLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "Force Metadata Last Write Time to Creation Time"), Required] public bool? ForceMetadataLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "Force Resize Last Write Time to Creation Time"), Required] public bool? ForceResizeLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "GenealogicalDataCommunication File"), Required] public string GenealogicalDataCommunicationFile { get; set; }
    [Display(Name = "Ignore Extensions"), Required] public string[] IgnoreExtensions { get; set; }
    [Display(Name = "Ignore Relative Paths"), Required] public string[] IgnoreRelativePaths { get; set; }
    [Display(Name = "Julie Phares Copy Birthdays"), Required] public string[] JLinks { get; set; }
    [Display(Name = "Load Or Create Then Save Distance Results"), Required] public string[] LoadOrCreateThenSaveDistanceResultsForOutputResolutions { get; set; }
    [Display(Name = "Load Or Create Then Save Image Faces Results"), Required] public string[] LoadOrCreateThenSaveImageFacesResultsForOutputResolutions { get; set; }
    [Display(Name = "Location Digits"), Required] public int? LocationDigits { get; set; }
    [Display(Name = "Location Factor"), Required] public int? LocationFactor { get; set; }
    [Display(Name = "Look for Abandoned"), Required] public bool? LookForAbandoned { get; set; }
    [Display(Name = "Mapping Default Name"), Required] public string MappingDefaultName { get; set; }
    [Display(Name = "Mapping Use Deterministic Hash Code Unknown Face Key Value Pairs for Add to Mapping"), Required] public bool? MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForAddToMapping { get; set; }
    [Display(Name = "Mapping Use Deterministic Hash Code Unknown Face Key Value Pairs for Save Mapping"), Required] public bool? MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForSaveMapping { get; set; }
    [Display(Name = "Mixed Year Relative Paths"), Required] public string[] MixedYearRelativePaths { get; set; }
    [Display(Name = "Model Directory"), Required] public string ModelDirectory { get; set; }
    [Display(Name = "Model Name"), Required] public string ModelName { get; set; }
    [Display(Name = "Number Jitters"), Required] public int? NumberOfJitters { get; set; }
    [Display(Name = "Number of Times To Up Sample"), Required] public int? NumberOfTimesToUpsample { get; set; }
    [Display(Name = "Output Extension"), Required] public string OutputExtension { get; set; }
    [Display(Name = "Output Quality"), Required] public int? OutputQuality { get; set; }
    [Display(Name = "Output Resolutions"), Required] public string[] OutputResolutions { get; set; }
    [Display(Name = "Override For Face Images"), Required] public bool? OverrideForFaceImages { get; set; }
    [Display(Name = "Override For Face Landmark Images"), Required] public bool? OverrideForFaceLandmarkImages { get; set; }
    [Display(Name = "Override For Resize Images"), Required] public bool? OverrideForResizeImages { get; set; }
    [Display(Name = "Person Birthday First Year"), Required] public int? PersonBirthdayFirstYear { get; set; }
    [Display(Name = "Person Birthday Format"), Required] public string PersonBirthdayFormat { get; set; }
    [Display(Name = "Person Characters"), Required] public string PersonCharacters { get; set; }
    [Display(Name = "Person Characters Copy Count"), Required] public int? PersonCharactersCopyCount { get; set; }
    [Display(Name = "PersonKey Format"), Required] public string PersonKeyFormat { get; set; }
    [Display(Name = "Predictor Model Name"), Required] public string PredictorModelName { get; set; }
    [Display(Name = "Properties Changed For Distance"), Required] public bool? PropertiesChangedForDistance { get; set; }
    [Display(Name = "Properties Changed For Faces"), Required] public bool? PropertiesChangedForFaces { get; set; }
    [Display(Name = "Properties Changed For Index"), Required] public bool? PropertiesChangedForIndex { get; set; }
    [Display(Name = "Properties Changed For Metadata"), Required] public bool? PropertiesChangedForMetadata { get; set; }
    [Display(Name = "Properties Changed For Resize"), Required] public bool? PropertiesChangedForResize { get; set; }
    [Display(Name = "Property Configuration"), Required] public Property.Models.Configuration PropertyConfiguration { get; set; }
    [Display(Name = "Sorting Days Delta Tolerance"), Required] public int[] RangeDaysDeltaTolerance { get; set; }
    [Display(Name = "Face Distance Tolerance"), Required] public float[] RangeDistanceTolerance { get; set; }
    [Display(Name = "Face Area Permille Tolerance"), Required] public float[] RangeFaceAreaTolerance { get; set; }
    [Display(Name = "Location Minimum Confidence"), Required] public float[] RangeFaceConfidence { get; set; }
    [Display(Name = "Reverse"), Required] public bool? Reverse { get; set; }
    [Display(Name = "Save Blur Hash For Output Resolutions"), Required] public string[] SaveBlurHashForOutputResolutions { get; set; }
    [Display(Name = "Save Face Distances For Output Resolutions"), Required] public string[] SaveFaceDistancesForOutputResolutions { get; set; }
    [Display(Name = "Save Face Landmark For Output Resolutions"), Required] public string[] SaveFaceLandmarkForOutputResolutions { get; set; }
    [Display(Name = "Save Full Year Of Random Files"), Required] public bool? SaveFullYearOfRandomFiles { get; set; }
    [Display(Name = "Save Mapped"), Required] public string[] SaveMappedForOutputResolutions { get; set; }
    [Display(Name = "Save Resized Images by Person Key Formatted"), Required] public string[] SaveFilteredOriginalImagesFromJLinksForOutputResolutions { get; set; }
    [Display(Name = "Save For Individually"), Required] public bool? SaveIndividually { get; set; }
    [Display(Name = "Save Random For Output Resolutions"), Required] public string[] SaveRandomForOutputResolutions { get; set; }
    [Display(Name = "Save Resized Subfiles"), Required] public bool? SaveResizedSubfiles { get; set; }
    [Display(Name = "Save Shortcuts"), Required] public string[] SaveShortcutsForOutputResolutions { get; set; }
    [Display(Name = "Save Sorting Without Person"), Required] public bool? SaveSortingWithoutPerson { get; set; }
    [Display(Name = "Skip Not Skip Directories"), Required] public string[] SkipNotSkipDirectories { get; set; }
    [Display(Name = "Skip Older Than Days"), Required] public int? SkipOlderThanDays { get; set; }
    [Display(Name = "Skip Search"), Required] public bool? SkipSearch { get; set; }
    [Display(Name = "SortingMaximumPerFaceShould be High"), Required] public int? SortingMaximumPerFaceShouldBeHigh { get; set; }
    [Display(Name = "Sorting Maximum Per Key"), Required] public int? SortingMaximumPerKey { get; set; }
    [Display(Name = "Sorting Minimum to use Sigma"), Required] public int? SortingMinimumToUseSigma { get; set; }
    [Display(Name = "Test Distance Results"), Required] public bool? TestDistanceResults { get; set; }
    [Display(Name = "Use Filter Tries"), Required] public int? UseFilterTries { get; set; }
    [Display(Name = "Valid Resolutions"), Required] public string[] ValidResolutions { get; set; }

#nullable restore

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

    private static Models.Configuration Get(Configuration? configuration)
    {
        Models.Configuration result;
        if (configuration is null)
            throw new NullReferenceException(nameof(configuration));
        if (configuration.CheckDFaceAndUpWriteDates is null)
            throw new NullReferenceException(nameof(configuration.CheckDFaceAndUpWriteDates));
        if (configuration.CheckJsonForDistanceResults is null)
            throw new NullReferenceException(nameof(configuration.CheckJsonForDistanceResults));
        configuration.CopyFacesAndSaveFaceLandmarkForOutputResolutions ??= Array.Empty<string>();
        if (configuration.CrossDirectoryMaxItemsInDistanceCollection is null)
            throw new NullReferenceException(nameof(configuration.CrossDirectoryMaxItemsInDistanceCollection));
        if (configuration.DeletePossibleDuplicates is null)
            throw new NullReferenceException(nameof(configuration.DeletePossibleDuplicates));
        if (configuration.DistanceFactor is null)
            throw new NullReferenceException(nameof(configuration.DistanceFactor));
        if (configuration.DistanceMoveUnableToMatch is null)
            throw new NullReferenceException(nameof(configuration.DistanceMoveUnableToMatch));
        if (configuration.DistancePixelDistanceTolerance is null)
            throw new NullReferenceException(nameof(configuration.DistancePixelDistanceTolerance));
        if (configuration.DistanceRenameToMatch is null)
            throw new NullReferenceException(nameof(configuration.DistanceRenameToMatch));
        if (configuration.FaceAreaPermyriad is null)
            throw new NullReferenceException(nameof(configuration.FaceAreaPermyriad));
        if (configuration.FaceDistanceHiddenImageFactor is null)
            throw new NullReferenceException(nameof(configuration.FaceDistanceHiddenImageFactor));
        if (configuration.FaceConfidencePercent is null)
            throw new NullReferenceException(nameof(configuration.FaceConfidencePercent));
        if (configuration.FaceDistancePermyriad is null)
            throw new NullReferenceException(nameof(configuration.FaceDistancePermyriad));
        if (configuration.FocusDirectory is null)
            throw new NullReferenceException(nameof(configuration.FocusDirectory));
        if (configuration.FocusModel is null)
            throw new NullReferenceException(nameof(configuration.FocusModel));
        if (configuration.ForceFaceLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceFaceLastWriteTimeToCreationTime));
        if (configuration.ForceMetadataLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceMetadataLastWriteTimeToCreationTime));
        if (configuration.ForceResizeLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceResizeLastWriteTimeToCreationTime));
        if (configuration.GenealogicalDataCommunicationFile is null)
            throw new NullReferenceException(nameof(configuration.GenealogicalDataCommunicationFile));
        if (configuration.IgnoreExtensions is null)
            throw new NullReferenceException(nameof(configuration.IgnoreExtensions));
        configuration.IgnoreRelativePaths ??= Array.Empty<string>();
        configuration.LoadOrCreateThenSaveDistanceResultsForOutputResolutions ??= Array.Empty<string>();
        configuration.LoadOrCreateThenSaveImageFacesResultsForOutputResolutions ??= Array.Empty<string>();
        if (configuration.LocationDigits is null)
            throw new NullReferenceException(nameof(configuration.LocationDigits));
        if (configuration.LocationFactor is null)
            throw new NullReferenceException(nameof(configuration.LocationFactor));
        if (configuration.LookForAbandoned is null)
            throw new NullReferenceException(nameof(configuration.LookForAbandoned));
        if (configuration.MappingDefaultName is null)
            throw new NullReferenceException(nameof(configuration.MappingDefaultName));
        if (configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForAddToMapping is null)
            throw new NullReferenceException(nameof(configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForAddToMapping));
        if (configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForSaveMapping is null)
            throw new NullReferenceException(nameof(configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForSaveMapping));
        if (configuration.MixedYearRelativePaths is null)
            throw new NullReferenceException(nameof(configuration.MixedYearRelativePaths));
        if (configuration.NumberOfJitters is null)
            throw new NullReferenceException(nameof(configuration.NumberOfJitters));
        if (configuration.NumberOfTimesToUpsample is null)
            throw new NullReferenceException(nameof(configuration.NumberOfTimesToUpsample));
        if (configuration.OutputQuality is null)
            throw new NullReferenceException(nameof(configuration.OutputQuality));
        if (configuration.OutputResolutions is null)
            throw new NullReferenceException(nameof(configuration.OutputResolutions));
        if (configuration.OverrideForFaceImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForFaceImages));
        if (configuration.OverrideForFaceLandmarkImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForFaceLandmarkImages));
        if (configuration.OverrideForResizeImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForResizeImages));
        if (configuration.PersonBirthdayFirstYear is null)
            throw new NullReferenceException(nameof(configuration.PersonBirthdayFirstYear));
        if (configuration.PersonBirthdayFormat is null)
            throw new NullReferenceException(nameof(configuration.PersonBirthdayFormat));
        if (configuration.PersonCharacters is null)
            throw new NullReferenceException(nameof(configuration.PersonCharacters));
        if (configuration.PersonCharactersCopyCount is null)
            throw new NullReferenceException(nameof(configuration.PersonCharactersCopyCount));
        if (configuration.PersonKeyFormat is null)
            throw new NullReferenceException(nameof(configuration.PersonKeyFormat));
        if (configuration.PropertiesChangedForDistance is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForDistance));
        if (configuration.PropertiesChangedForFaces is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForFaces));
        if (configuration.PropertiesChangedForIndex is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForIndex));
        if (configuration.PropertiesChangedForMetadata is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForMetadata));
        if (configuration.PropertiesChangedForResize is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForResize));
        if (configuration.RangeDaysDeltaTolerance is null || configuration.RangeDaysDeltaTolerance.Length != 3)
            throw new NullReferenceException(nameof(configuration.RangeDaysDeltaTolerance));
        if (configuration.RangeFaceAreaTolerance is null || configuration.RangeFaceAreaTolerance.Length != 3)
            throw new NullReferenceException(nameof(configuration.RangeFaceAreaTolerance));
        if (configuration.RangeFaceConfidence is null || configuration.RangeFaceConfidence.Length != 3)
            throw new NullReferenceException(nameof(configuration.RangeFaceConfidence));
        if (configuration.RangeDistanceTolerance is null || configuration.RangeDistanceTolerance.Length != 3)
            throw new NullReferenceException(nameof(configuration.RangeDistanceTolerance));
        if (configuration.Reverse is null)
            throw new NullReferenceException(nameof(configuration.Reverse));
        configuration.SaveBlurHashForOutputResolutions ??= Array.Empty<string>();
        configuration.SaveFaceDistancesForOutputResolutions ??= Array.Empty<string>();
        configuration.SaveFaceLandmarkForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SaveFullYearOfRandomFiles is null)
            throw new NullReferenceException(nameof(configuration.SaveFullYearOfRandomFiles));
        configuration.SaveMappedForOutputResolutions ??= Array.Empty<string>();
        configuration.SaveFilteredOriginalImagesFromJLinksForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SaveIndividually is null)
            throw new NullReferenceException(nameof(configuration.SaveIndividually));
        configuration.SaveRandomForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SaveResizedSubfiles is null)
            throw new NullReferenceException(nameof(configuration.SaveResizedSubfiles));
        configuration.SaveShortcutsForOutputResolutions ??= Array.Empty<string>();
        configuration.SaveShortcutsForOutputResolutions ??= Array.Empty<string>();
        configuration.SkipNotSkipDirectories ??= Array.Empty<string>();
        if (configuration.SaveSortingWithoutPerson is null)
            throw new NullReferenceException(nameof(configuration.SaveSortingWithoutPerson));
        if (configuration.SkipSearch is null)
            throw new NullReferenceException(nameof(configuration.SkipSearch));
        if (configuration.SortingMaximumPerFaceShouldBeHigh is null)
            throw new NullReferenceException(nameof(configuration.SortingMaximumPerFaceShouldBeHigh));
        if (configuration.SortingMaximumPerKey is null)
            throw new NullReferenceException(nameof(configuration.SortingMaximumPerKey));
        if (configuration.SortingMinimumToUseSigma is null)
            throw new NullReferenceException(nameof(configuration.SortingMinimumToUseSigma));
        if (configuration.TestDistanceResults is null)
            throw new NullReferenceException(nameof(configuration.TestDistanceResults));
        if (configuration.UseFilterTries is null)
            throw new NullReferenceException(nameof(configuration.UseFilterTries));
        if (configuration.ValidResolutions is null)
            throw new NullReferenceException(nameof(configuration.ValidResolutions));
        _ = DateTime.Now.AddDays(-configuration.RangeDaysDeltaTolerance[1]);
        result = new(configuration.PropertyConfiguration,
                     configuration.CheckDFaceAndUpWriteDates.Value,
                     configuration.CheckJsonForDistanceResults.Value,
                     configuration.CopyFacesAndSaveFaceLandmarkForOutputResolutions,
                     configuration.CrossDirectoryMaxItemsInDistanceCollection.Value,
                     configuration.DeletePossibleDuplicates.Value,
                     configuration.DistanceFactor.Value,
                     configuration.DistanceMoveUnableToMatch.Value,
                     configuration.DistancePixelDistanceTolerance.Value,
                     configuration.DistanceRenameToMatch.Value,
                     configuration.FaceAreaPermyriad.Value,
                     configuration.FaceConfidencePercent.Value,
                     configuration.FaceDistanceHiddenImageFactor.Value,
                     configuration.FaceDistancePermyriad.Value,
                     configuration.FocusDirectory,
                     configuration.FocusModel,
                     configuration.ForceFaceLastWriteTimeToCreationTime.Value,
                     configuration.ForceMetadataLastWriteTimeToCreationTime.Value,
                     configuration.ForceResizeLastWriteTimeToCreationTime.Value,
                     configuration.GenealogicalDataCommunicationFile,
                     configuration.IgnoreExtensions,
                     configuration.IgnoreRelativePaths,
                     configuration.JLinks,
                     configuration.LoadOrCreateThenSaveDistanceResultsForOutputResolutions,
                     configuration.LoadOrCreateThenSaveImageFacesResultsForOutputResolutions,
                     configuration.LocationDigits.Value,
                     configuration.LocationFactor.Value,
                     configuration.LookForAbandoned.Value,
                     configuration.MappingDefaultName,
                     configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForAddToMapping.Value,
                     configuration.MappingUseDeterministicHashCodeUnknownFaceKeyValuePairsForSaveMapping.Value,
                     configuration.MixedYearRelativePaths,
                     configuration.ModelDirectory,
                     configuration.ModelName,
                     configuration.OutputExtension,
                     configuration.OutputQuality.Value,
                     configuration.OutputResolutions,
                     configuration.OverrideForFaceImages.Value,
                     configuration.OverrideForFaceLandmarkImages.Value,
                     configuration.OverrideForResizeImages.Value,
                     configuration.PersonBirthdayFirstYear.Value,
                     configuration.PersonBirthdayFormat,
                     configuration.PersonCharacters,
                     configuration.PersonCharactersCopyCount.Value,
                     configuration.PersonKeyFormat,
                     configuration.PredictorModelName,
                     configuration.PropertiesChangedForDistance.Value,
                     configuration.PropertiesChangedForFaces.Value,
                     configuration.PropertiesChangedForIndex.Value,
                     configuration.PropertiesChangedForMetadata.Value,
                     configuration.PropertiesChangedForResize.Value,
                     configuration.RangeDaysDeltaTolerance,
                     configuration.RangeDistanceTolerance,
                     configuration.RangeFaceAreaTolerance,
                     configuration.RangeFaceConfidence,
                     configuration.Reverse.Value,
                     configuration.SaveBlurHashForOutputResolutions,
                     configuration.SaveFaceDistancesForOutputResolutions,
                     configuration.SaveFaceLandmarkForOutputResolutions,
                     configuration.SaveFilteredOriginalImagesFromJLinksForOutputResolutions,
                     configuration.SaveIndividually.Value,
                     configuration.SaveFullYearOfRandomFiles.Value,
                     configuration.SaveMappedForOutputResolutions,
                     configuration.SaveRandomForOutputResolutions,
                     configuration.SaveResizedSubfiles.Value,
                     configuration.SaveShortcutsForOutputResolutions,
                     configuration.SaveSortingWithoutPerson.Value,
                     configuration.SkipNotSkipDirectories,
                     configuration.SkipOlderThanDays,
                     configuration.SkipSearch.Value,
                     configuration.SortingMaximumPerFaceShouldBeHigh.Value,
                     configuration.SortingMaximumPerKey.Value,
                     configuration.SortingMinimumToUseSigma.Value,
                     configuration.TestDistanceResults.Value,
                     configuration.UseFilterTries.Value,
                     configuration.ValidResolutions);
        return result;
    }

    public static Models.Configuration Get(IsEnvironment isEnvironment, IConfigurationRoot configurationRoot, Property.Models.Configuration propertyConfiguration)
    {
        Models.Configuration result;
        Configuration? configuration;
        if (isEnvironment is null)
            configuration = configurationRoot.Get<Configuration>();
        else
        {
            string environmentName = IsEnvironment.GetEnvironmentName(isEnvironment);
            string section = string.Concat(environmentName, ":", nameof(Configuration));
            IConfigurationSection configurationSection = configurationRoot.GetSection(section);
            configuration = configurationSection.Get<Configuration>();
        }
        result = Get(configuration);
        result.SetAndUpdate(propertyConfiguration, configuration?.NumberOfJitters, configuration?.NumberOfTimesToUpsample, configuration?.ModelName, configuration?.PredictorModelName);
        return result;
    }

}