namespace View_by_Distance.Metadata.Models.Stateless.Methods;

public interface IMetadata
{

    DateTime? TestStatic_GetMinimumDateTime(DateTime?[] dateTimes, int year, IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetMinimumDateTime(dateTimes, year, directories);
    static DateTime? GetMinimumDateTime(DateTime?[] dateTimes, int year, IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetMinimumDateTime(directories, dateTimes, year);

    DateTime? TestStatic_GetMinimumDateTime(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetMinimumDateTime(directories);
    static DateTime? GetMinimumDateTime(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetMinimumDateTime(directories, dateTimes: null, year: null);

    string? TestStatic_GetModel(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetModel(directories);
    static string? GetModel(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetModel(directories);

    string? TestStatic_GetFaceEncoding(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetFaceEncoding(directories);
    static string? GetFaceEncoding(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetFaceEncoding(directories);

    string? TestStatic_GetOutputResolution(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        GetOutputResolution(directories);
    static string? GetOutputResolution(IReadOnlyList<MetadataExtractor.Directory> directories) =>
        Metadata.GetOutputResolution(directories);

    int TestStatic_GetOrientation(List<KeyValuePair<string, string>> metadataCollection) =>
        GetOrientation(metadataCollection);
    static int GetOrientation(List<KeyValuePair<string, string>> metadataCollection) =>
        Metadata.GetOrientation(metadataCollection);

}